import java.util.*;


 // A simple queue with a linked list data structure.
     public class  Queue {
            QNode head; // null if empty
            QNode tail;
 
            final class QNode {
                public Object   object;
                public QNode    next;   // null if end
                public QNode(Object object, QNode next) {
                    this.object = object;
                    this.next = next;
                }
            }
 
            public void enqueue(Object anObject) {
                if (head == null) {
                    head = tail = new QNode(anObject, null);
                } else {
                    tail.next = new QNode(anObject, null);
                    tail = tail.next;
                }
            }
 
            public Object dequeue() {
                if (head == null) {
                    throw new NoSuchElementException("No more elements");
                }
 
                Object retval = head.object;
                QNode oldHead = head;
                head = head.next;
                if (head == null) {
                    tail = null;
                } else {
                    oldHead.next = null;
                }
                return retval;
            }

       
            public Object firstObject() {
                if (head == null) {
                    throw new NoSuchElementException("No more elements");
                }
 
                return head.object;
            }
            public boolean isEmpty() {
                return head == null;
            }
 
        } // End of class Queue
 

